;; Determines whether sets s1 and s2 contain
;; exactly the same sets of values.
;; Representation independent.
(define (set-eq? s1 s2)
  (define (helper l1 l2)
    (cond ((null? l1) #t)
	  ((= (car l1) (car l2))
	   (helper (cdr l1) (cdr l2)))
	  (else #f)))
  (let ((l1 (sort (set-to-list s1) <))
	(l2 (sort (set-to-list s2) <)))
    (if (= (length l1) (length l2))
	(helper l1 l2)
	#f)))
	
;; Alternative implementation using an 
;; advanced form of map.
(define (set-eq? s1 s2)
  (define (bool-and a b) (and a b))
  (let ((l1 (sort (set-to-list s1) <))
	(l2 (sort (set-to-list s2) <)))
    (if (= (length l1) (length l2))
	(fold-right bool-and #t (map = l1 l2))
	#f)))